--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")


local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}
local InkedColorsHightlight = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 0.1}

local HightlightTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsHoverTex"
local PushedTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsPushedTex"
--local ThisTexture = ("Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButtons")

	

local ButtonSize = 40
local MySpacing = 1
local BorderSize = 12
local BorderPadding = 0

local MoverAB3 = CreateFrame("Frame","AB3Drag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	--MoverAB3:SetSize((ButtonSize * 12)+12, ButtonSize)
	MoverAB3:SetPoint("CENTER", UIParent,"BOTTOM",-80, 60)
	MoverAB3:SetFrameStrata("FULLSCREEN_DIALOG")
	MoverAB3:SetClampedToScreen(true)
	MoverAB3:SetClampRectInsets(0, 0, 0,0)
local MoverAB3Text  = MoverAB3:CreateFontString(nil, "OVERLAY")
	MoverAB3Text:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.TTF", 15, "OUTLINE")
	MoverAB3Text:SetPoint("CENTER",MoverAB3,"CENTER", 0,0); 
	MoverAB3Text:SetText("")

local function UpdateMe()
	if(Inked.db.profile.lockframes == false) then
		local point, relativeTo, relativePoint, xOfs, yOfs = MoverAB3:GetPoint(n)
			Inked.db.profile.MoverAB3X = xOfs
			Inked.db.profile.MoverAB3Y = yOfs
			Inked.db.profile.MoverAB3Point = point
			MoverAB3Text:SetText("Inked Bar 3")				
	end	
end	

local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe) 
local function CreateMoverBackdrop(frame)
	frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
	insets = {top = -2, left = -2, bottom = -2, right = -2}})
	frame:SetBackdropColor(0,0.55,0.95,0.45)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function MakeBar3()
	if Inked.db.profile.UseActionBars == false then return end
	-- for i = 2, 12 do	
				-- _G["MultiBarBottomRightButton"..i]:ClearAllPoints();
				-- _G["MultiBarBottomRightButton"..i]:SetPoint("CENTER", _G["MultiBarBottomRightButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)
				-- local InkedBar3 = _G["MultiBarBottomRightButton"..i]
		-- InkedBar3:SetAttribute("showgrid", 1)
				-- InkedBar3:SetAttribute("statehidden", false)
				
			-- end
			
		
	local Bar3holder = CreateFrame("Frame", "Bar3holder", UIParent, "SecureHandlerStateTemplate")
	Bar3holder:ClearAllPoints()
	Bar3holder:SetSize(ButtonSize * 12 + MySpacing * 11, ButtonSize)	

	ButtonSize = Inked.db.profile.AB3ButtonSize
	
		
		if  MultiBarBottomRightButton1:IsVisible() then
			for i = 1, 12 do
					local Holder = CreateFrame("Frame",nil,UIParent)
						Holder:SetWidth(ButtonSize)
						Holder:SetHeight(ButtonSize)
						Holder:SetPoint("CENTER", _G["MultiBarBottomRightButton"..i],"CENTER",0, 0)
						local Holdertex = Holder:CreateTexture(nil, "BACKGROUND")
					Holdertex:SetAllPoints()
					local ThisTexture = ("Interface\\Addons\\Inked\\Graphics\\Buttons\\PsychoButton")
					Holdertex:SetTexture(ThisTexture)
					if Inked.db.profile.ClassABColor == true then
									Holdertex:SetVertexColor(InkedColors.r, InkedColors.g, InkedColors.b, InkedColors.a)
								elseif Inked.db.profile.ClassABColor == false then
									if Inked.db.profile.CustomABColor == true then
										Holdertex:SetVertexColor(Inked.db.profile.ABColorR,Inked.db.profile.ABColorG,Inked.db.profile.ABColorB,Inked.db.profile.ABColorA)
									elseif Inked.db.profile.CustomABColor == false then
										Holdertex:SetVertexColor(1,1,1,1)
									end
								end
				end
		end
		
		if Inked.db.profile.AB3Layout == 1 then
		--print("layout 1")
			MultiBarBottomRightButton1:ClearAllPoints()
			MultiBarBottomRightButton1:SetPoint("BOTTOMLEFT", Bar3holder, 0, 0)
			for i = 2, 12 do	
				_G["MultiBarBottomRightButton"..i]:ClearAllPoints();
				_G["MultiBarBottomRightButton"..i]:SetPoint("CENTER", _G["MultiBarBottomRightButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)
				
			end
			MoverAB3:SetSize((ButtonSize * 12)+12, ButtonSize)
			Bar3holder:SetPoint("LEFT", MoverAB3, 0,0)
		end
		if Inked.db.profile.AB3Layout == 2 then
	--	print("layout 2")
			MultiBarBottomRightButton1:ClearAllPoints()
			MultiBarBottomRightButton1:SetPoint("BOTTOMLEFT", Bar3holder, 0, 0)
			_G["MultiBarBottomRightButton7"]:ClearAllPoints();
			_G["MultiBarBottomRightButton7"]:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton1, 0, -ButtonSize+(-MySpacing*1.5))
			for i = 2, 6 do	
				_G["MultiBarBottomRightButton"..i]:ClearAllPoints();
				_G["MultiBarBottomRightButton"..i]:SetPoint("CENTER", _G["MultiBarBottomRightButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)	
			end
			for i = 8,12 do	
				_G["MultiBarBottomRightButton"..i]:ClearAllPoints();
				_G["MultiBarBottomRightButton"..i]:SetPoint("CENTER", _G["MultiBarBottomRightButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)			
			end
			MoverAB3:SetSize((ButtonSize * 6)+12, (ButtonSize*2) +12)
			Bar53holder:SetPoint("LEFT", MoverAB3, 0,(ButtonSize*0.25))
		end
		if Inked.db.profile.AB3Layout == 3 then
		--print("layout 3")
			MultiBarBottomRightButton1:ClearAllPoints()
			MultiBarBottomRightButton1:SetPoint("BOTTOMLEFT", Bar3holder, 0, 0)
			_G["MultiBarBottomRightButton5"]:ClearAllPoints();
			_G["MultiBarBottomRightButton5"]:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton1, 0, -ButtonSize+(-MySpacing*1.5))
			_G["MultiBarBottomRightButton9"]:ClearAllPoints();
			_G["MultiBarBottomRightButton9"]:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton5, 0, -ButtonSize+(-MySpacing*1.5))
			for i = 2, 4 do	
				_G["MultiBarBottomRightButton"..i]:ClearAllPoints();
				_G["MultiBarBottomRightButton"..i]:SetPoint("CENTER", _G["MultiBarBottomRightButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)	
			end
			for i = 6,8 do	
				_G["MultiBarBottomRightButton"..i]:ClearAllPoints();
				_G["MultiBarBottomRightButton"..i]:SetPoint("CENTER", _G["MultiBarBottomRightButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)			
			end
			for i = 10,12 do	
				_G["MultiBarBottomRightButton"..i]:ClearAllPoints();
				_G["MultiBarBottomRightButton"..i]:SetPoint("CENTER", _G["MultiBarBottomRightButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)			
			end
			MoverAB3:SetSize((ButtonSize * 4), (ButtonSize*3))
			Bar3holder:SetPoint("LEFT", MoverAB3, 0, ButtonSize/1.75)
		end
		if Inked.db.profile.AB3Layout == 4 then
		--print("layout 4")
			MultiBarBottomRightButton1:ClearAllPoints()
			MultiBarBottomRightButton1:SetPoint("BOTTOMLEFT", Bar3holder, 0, 0)
			for i = 2, 12 do	
				_G["MultiBarBottomRightButton"..i]:ClearAllPoints();
				_G["MultiBarBottomRightButton"..i]:SetPoint("CENTER", _G["MultiBarBottomRightButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))
				
			end
			MoverAB3:SetSize(ButtonSize, (ButtonSize*12) +12)
			Bar3holder:SetPoint("LEFT", MoverAB3, 0,(ButtonSize*5.25))
		end
		if Inked.db.profile.AB3Layout == 5 then
		--print("layout 5")
			MultiBarBottomRightButton1:ClearAllPoints()
			MultiBarBottomRightButton1:SetPoint("BOTTOMLEFT", Bar3holder, 0, 0)
			_G["MultiBarBottomRightButton7"]:ClearAllPoints();
			_G["MultiBarBottomRightButton7"]:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton1, -ButtonSize+(-MySpacing*1.5), 0)
			for i = 2, 6 do	
				_G["MultiBarBottomRightButton"..i]:ClearAllPoints();
				_G["MultiBarBottomRightButton"..i]:SetPoint("CENTER", _G["MultiBarBottomRightButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))	
			end
			for i = 8,12 do	
				_G["MultiBarBottomRightButton"..i]:ClearAllPoints();
				_G["MultiBarBottomRightButton"..i]:SetPoint("CENTER", _G["MultiBarBottomRightButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))			
			end
			MoverAB3:SetSize((ButtonSize * 2)+12, (ButtonSize*6) +12)
			Bar3holder:SetPoint("LEFT", MoverAB3, ButtonSize,(ButtonSize*2.25))
		end
		if Inked.db.profile.AB3Layout == 6 then
		--print("layout 6")
			MultiBarBottomRightButton1:ClearAllPoints()
			MultiBarBottomRightButton1:SetPoint("BOTTOMLEFT", Bar3holder, 0, 0)
			_G["MultiBarBottomRightButton5"]:ClearAllPoints();
			_G["MultiBarBottomRightButton5"]:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton1, -ButtonSize+(-MySpacing*1.5), 0)
			_G["MultiBarBottomRightButton9"]:ClearAllPoints();
			_G["MultiBarBottomRightButton9"]:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton5, -ButtonSize+(-MySpacing*1.5), 0)

			for i = 2, 4 do	
				_G["MultiBarBottomRightButton"..i]:ClearAllPoints();
				_G["MultiBarBottomRightButton"..i]:SetPoint("CENTER", _G["MultiBarBottomRightButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))	
			end
			for i = 6, 8 do	
				_G["MultiBarBottomRightButton"..i]:ClearAllPoints();
				_G["MultiBarBottomRightButton"..i]:SetPoint("CENTER", _G["MultiBarBottomRightButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))	
			end
			for i = 10,12 do	
				_G["MultiBarBottomRightButton"..i]:ClearAllPoints();
				_G["MultiBarBottomRightButton"..i]:SetPoint("CENTER", _G["MultiBarBottomRightButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))			
			end
			MoverAB3:SetSize((ButtonSize * 3)+12, (ButtonSize*4) +12)
			Bar3holder:SetPoint("LEFT", MoverAB3, (ButtonSize*2)+2,(ButtonSize*1.25))
		end	
		
		for i = 1, 12 do
			local InkedBar3 = _G["MultiBarBottomRightButton"..i]
			_G["MultiBarBottomRightButton"..i]:SetWidth(ButtonSize)
			_G["MultiBarBottomRightButton"..i]:SetHeight(ButtonSize)
			 -- InkedBar3:SetAttribute("showgrid", 1)
				-- InkedBar3:SetAttribute("statehidden", false)
			 -- InkedBar3.NormalTexture:SetTexture(nil)

			
			local Highlight = InkedBar3:GetHighlightTexture()	
			local Pushed = InkedBar3:GetPushedTexture()
			Highlight:SetTexture(HightlightTex)
			Highlight:SetVertexColor(InkedColorsHightlight.r,InkedColorsHightlight.g,InkedColorsHightlight.b,InkedColorsHightlight.a)
			Pushed:SetTexture(PushedTex)		
		end

		if(Inked.db.profile.lockframes == false) then
			MoverAB3:ClearAllPoints()
			if Inked.db.profile.MoverAB3Point == nil then
				MoverAB3:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverAB3X,Inked.db.profile.MoverAB3Y)
			else
				MoverAB3:SetPoint(Inked.db.profile.MoverAB3Point, UIParent,Inked.db.profile.MoverAB3X,Inked.db.profile.MoverAB3Y)
			end
			CreateMoverBackdrop(MoverAB3)
			MoverAB3:SetMovable(true)
			MoverAB3:EnableMouse(true)
			MoverAB3:RegisterForDrag("LeftButton")
			MoverAB3:SetScript("OnDragStart", MoverAB3.StartMoving)
			MoverAB3:SetScript("OnDragStop", MoverAB3.StopMovingOrSizing)
			MoverAB3:SetUserPlaced(true)
						
		elseif Inked.db.profile.MoverAB3Point == nil then
				MoverAB3:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverAB3X,Inked.db.profile.MoverAB3Y)
			else
				MoverAB3:SetPoint(Inked.db.profile.MoverAB3Point, UIParent,Inked.db.profile.MoverAB3X,Inked.db.profile.MoverAB3Y)
		end
		--if(Inked.db.profile.lockframes == true) then
			-- Bar3holder:ClearAllPoints()
			-- Bar3holder:SetPoint("LEFT", MoverAB3, 0, 0)
		--end
end		
		local InkedLoginFrame=CreateFrame("Frame")
		InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")
		InkedLoginFrame:RegisterEvent("CINEMATIC_STOP")
		InkedLoginFrame:SetScript("OnEvent", function(self, event) 
		
			MakeBar3()									
		end)